jdwtoa	proc dwValue, lpBuffer, DivOrNo
;____________________________________________________________________
    ; -----------------------------------------
    ; This procedure was written by Tim Roberts
    ; -----------------------------------------
    ; Modified slightly by Farrier to return a '0' when dwValue = 0
    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; EXAMPLE:
    ; invoke jdwtoa,edx,addr buffer
    ;
    ; Uses: eax, ecx, edx, esi, edi.
    ; -------------------------------------------------------------

	push	ebx
	push	edi
	push	esi
	mov		eax, [dwValue]
	mov		edi, [lpBuffer]
	cmp		eax, 0
	jne	.not_zero
		mov	byte [edi], '0'
		inc	edi
		mov	byte [edi], 0
		jmp	.dir_out
.not_zero:
; Is the value negative?
	jg	.positive
		mov byte [edi], '-'   ;store a minus sign
		inc edi
		neg eax                   ;and invert the value
.positive:
	mov	esi, edi				;save pointer to first digit
	mov	ecx, 10
;    .while (eax > 0)			;while there is more to convert...
.another_10:
		xor edx, edx			;clear edx for edx:eax div ecx
		div ecx					;leaves remainder--"next digit"--in edx
		add dl, '0'				;convert to ASCII
		mov [edi], dl			;store it
		inc edi
		cmp	eax, 0				;are we done
		jne	.another_10			;if not, divide again
;    .endw
	mov byte [edi], 0       ;terminate the string
; We now have all the digits, but in reverse order.
;    .while (esi < edi)
;	mov	ebx, 0				;keep track for commas
	mov		eax, edi
	sub		eax, esi
	cmp		[DivOrNo], 0
	je		.dont_push
	push	eax
.dont_push:
	dec		eax
	mov		ecx, 3
	mov		edx, 0
	div		cx
	mov		ebx, eax			;ebx holds # of commas
.switch_another:
		dec edi				;at this point esi is pointer to beginning of buffer, most signif.
							;edi points to last converted digit, least significant
		mov al, [esi]
		mov ah, [edi]
		mov [edi], al
		mov [esi], ah
		inc esi
;		inc	ebx
		cmp	esi, edi
		jb	.switch_another
;    .endw
.get_out:
	cmp		[DivOrNo], 0
	je		.dir_out
	mov		edx, 0
	mov		edi, [lpBuffer]	;most sig digit
	mov		esi, edi
	pop		eax				;length of string
	add		edi, eax		;points to least sig. digit
	mov		ecx, edi
	dec		ecx
	add		edi, ebx		;make space for commas
;	inc		edi				;make space for term. 0
	mov		byte [edi], 0	;new string termination
	dec		edi
.anot_dig:
	mov		al, [ecx]
	mov		[edi], al
	inc		edx
	dec		ecx
	dec		edi
	cmp		edi, esi
	je		.dir_out
	cmp		edi, ecx
	je		.dir_out
	cmp		edx, 3
	jne		.anot_dig
	mov		byte [edi], ','
	mov		edx, 0
	dec		edi
	cmp		edi, ecx
	jne		.anot_dig
.dir_out:
	pop		esi
	pop		edi
	pop		ebx
	ret

jdwtoa	endp

StrCopy	proc	lpSourc, lpDest
	
	
	ret
StrCopy	endp
